/***************************************************************************
 *            infowindow.h
 *
 *  Thu Feb 17 03:05:38 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _INFOWINDOW_H
#define _INFOWINDOW_H

#include <gtk/gtk.h>
#include "imuserdaemon.h"
#include "basicwindow.h"
#include "processingani.h"
#include "utilities.h"
#include "userutilities.h"
#include "gettext.h"

class userInfoWindow: public basicWindow
{
	public:
		userInfoWindow();
		~userInfoWindow();
		
	private:
		GtkWidget		  *notebook,
						  *updateBtn,
						  *closeBtn,
						  *saveBtn,
						  *sendBtn;
	
		GList			  *tabs;
	
		processingAni *sendAni;
	
		virtual GtkWidget* createWindowContent();
		virtual void	   destroyWindowContent();
		
		virtual gboolean   eventCallback(gint comment, gint lastResult, gpointer info);
	
		void startUpdate();
		void stopUpdate();
		void shiftInformation(gboolean update);


		//callbacks 	
		static void cb_switchTab(GtkWidget *w, GtkNotebookPage *page, guint newTab, userInfoWindow* uiw);
		static void cb_updateButtonClicked(userInfoWindow* uiw);
		static void cb_closeButtonClicked(userInfoWindow* uiw);
		static void cb_saveButtonClicked(userInfoWindow* uiw);
		static void cb_sendButtonClicked(userInfoWindow* self);
	
		GtkWidget* createButtonbar();
		GtkWidget* createGeneralTab();
		GtkWidget* createMoreTab();
		GtkWidget* createWorkTab();
		GtkWidget* createAboutTab();
		GtkWidget* createLastTab();
		GtkWidget* createInterestsTab();
	
	
		GtkWidget	*info_about;
		GtkWidget	*info_companyCity,
					*info_companyState,
					*info_companyAddress,
					*info_companyZip,
					*info_companyCountry,
					*info_companyTel,
					*info_companyFax,
					*info_companyISite,
					*info_companyName,
					*info_companyDep,
					*info_companyPos;	
		GtkWidget	*info_age,
					*info_gender,
					*info_isite,
					*info_birthyear,
					*info_birthmonth,
					*info_birthday,
					*info_language1,
					*info_language2,
					*info_language3;
		GtkWidget	*info_alias,
					*info_keepalias,
					*info_uin,
					*info_ip,
					*info_address,
					*info_tel,
					*info_state,
					*info_fax,
					*info_city,
					*info_mobile,
					*info_zip,
					*info_country,
					*info_email1,
					*info_email2,
					*info_emailold,
					*info_name1,
					*info_name2,
					*info_constate,
					*info_timezone;

};


#define UIT_MAKE_TABLE_ROW_ENTRY(table, label, labeltext, entry, entrytext, cstart, cend, row) \
	label = gtk_label_new(labeltext);								\
	gtk_widget_set_size_request(label, 110, -1);						\
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);			\
	gtk_misc_set_padding(GTK_MISC(label), 10, 0);					\
																	\
	entry = gtk_entry_new();										\
	gtk_entry_set_text(GTK_ENTRY(entry), entrytext);				\
	gtk_widget_set_size_request(entry, 100, -1);					\
																	\
	gtk_table_attach(GTK_TABLE(table), label, cstart, cstart+1, row, row+1, (GtkAttachOptions)0, (GtkAttachOptions)0, 0, 0);	\
	gtk_table_attach_defaults(GTK_TABLE(table), entry, cstart+1, cend, row, row+1);



#define UIT_MAKE_TABLE_ROW_CUSTOM(table, label, labeltext, customw, cstart, cend, row) \
	label = gtk_label_new(labeltext);								\
	gtk_widget_set_size_request(label, 110, -1);						\
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);			\
	gtk_misc_set_padding(GTK_MISC(label), 10, 0);					\
																	\
	gtk_table_attach(GTK_TABLE(table), label, cstart, cstart+1, row, row+1, (GtkAttachOptions)0, (GtkAttachOptions)0, 0, 0);	\
	gtk_table_attach_defaults(GTK_TABLE(table), customw, cstart+1, cend, row, row+1);


#define UIT_MAKE_LIST_BOX(w, sel, max, arr)											\
	w = gtk_combo_box_new_text();												\
	gtk_widget_set_size_request(w, 100, -1);									\
																				\
	for (gint i=0;i<max;i++)											\
	{																			\
		if (!i)																	\
			gtk_combo_box_append_text(GTK_COMBO_BOX(w), "keine Angabe");		\
		else																	\
			gtk_combo_box_append_text(GTK_COMBO_BOX(w), arr[i].szName);	\
	}																			\
	gtk_combo_box_set_active(GTK_COMBO_BOX(w), sel);


#endif /* _INFOWINDOW_H */
