/***************************************************************************
 *            mainwindow.h
 *
 *  Tue Jan 25 22:12:28 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _MAINWINDOW_H
#define _MAINWINDOW_H

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "imuserdaemon.h"
#include "settings.h"
#include "contactlist.h"
#include "trayicon.h"
#include "utilities.h"
#include "userutilities.h"
#include "gettext.h"



// different types of menus
enum userMenuGroup
{
	MENU_USER,
	MENU_STATUS,
	MENU_SYSTEM,
	MENU_DOUBLECLICK,
	MENU_NOTIFYBOX
};



// id's for menu elements
enum userMenuID
{
	MENU_OPENEVENT = 0xFFFF,
	MENU_REMOVEUSER,
	MENU_SHOWGROUPS,
	MENU_SHOWEMPTYGROUPS,
	MENU_SHOWOFFLINEUSERS,
	MENU_RELOADLIST,
	MENU_OPENALL,
	MENU_UPDATEALL,
	MENU_CHECKINVISIBLEALL,
	MENU_QUIT,
	MENU_NONE	= 0xC0CA11
};




typedef void(*mwMenuClickFunction)(GtkWidget* item, gint menu, gint selection, gpointer data);


class mainWindow
{
	public:
		GtkWidget	*menu_showEmptyGroups,
					*menu_showGroups,
					*menu_showOfflineUsers,
					*menu_openUserEvent,
					*menu_openAllEvents,
					*menu_userMenuLabel,
					*menu_users,
					*menu_status,
					*menu_editPersonalInfo,
					*menu_reloadContacts,
					*menu_statusInvisible,
					*statusButton,
					*window;
	
	
		contactList	*contacts;	
	
		mainWindow(mwMenuClickFunction mcf, GCallback quitfunc, gpointer cbdata);
		~mainWindow();	
	
		void setTitle(gchar* _title);
		void setPendingEventNotify(gboolean state);
	
		void updateStatus(guint status, gboolean isInvisible);
		void updateSystemInfo(gint noe, gchar* evname, gchar* appendix);
	
		void startTrayAnimation();
		void stopTrayAnimation();
		void setTrayBlinkEvent(basicEventInfo *ev);
		
		void setLockUserMenus(gboolean lock);
		
		void destroyWindow();
	
	private:
	
		GtkWidget	*notifyText,
					*notifyIcon,
					*mainMenu,
	
					*statusButtonIcon,
					*statusButtonText;
	
		GtkMenu		*statusMenu,
					*userMenu,
					*groupMenu;
	
		GList		*stateIcons;
	
		GdkPixbuf	*lastStatusPixbuf,
					*eventPixbuf;
						
		
		mwMenuClickFunction	menuCallBack;
		gpointer			menuCallBackData;
	
		trayIcon			*tray;
		gchar				trayIter;
		guint				trayConnectSource,
							trayBlinkSource,
							lastStatus;
		
		gboolean			trayShowEventIcon;
		
		gchar				*title;
	
		gboolean	isObscured;
	
		void trayClicked(GdkEventType type, guchar button);
		gboolean updateContactListViewMode();
		void createMenus();

	
	
		// callbacks
		static gboolean cb_contactListClicked(GtkTreeView* cList, GdkEventButton* event, mainWindow* mw);
		static void	 	cb_contactListActivated(GtkTreeView *tv, GtkTreePath *path, GtkTreeViewColumn *column, mainWindow* mw);
		static void	 	cb_menuClicked(GtkWidget* w, GtkWidget* toshow);
		static void 	cb_menuItemClicked(GtkWidget* item, mainWindow* mw);
		static gboolean	cb_destroyWindow(mainWindow* mw);
		static gboolean cb_visibilityChange(mainWindow* mw, GdkEventVisibility *event);
		static gboolean cb_trayClicked(mainWindow* mw, GdkEventButton* event);
		static gboolean cb_trayAnimation(mainWindow* mw);
		static gboolean cb_trayEventBlinking(mainWindow* mw);
		
		static gboolean cb_notifyBoxClicked(GtkWidget* box, GdkEventButton* event, mainWindow* mw);

		static void cb_settingsChangedCallback(gchar* sname, GList *values, mainWindow* self);
	
};

#endif /* _MAINWINDOW_H */
