/***************************************************************************
 *            requestdialog.h
 *
 *  Thu Feb 10 00:08:01 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _REQUESTDIALOG_H
#define _REQUESTDIALOG_H

#include <gtk/gtk.h>
#include "settings.h"
#include "basicwindow.h"
#include "imuserdaemon.h"
#include "utilities.h"
#include "processingani.h"
#include "gettext.h"

enum requestResults
{
	REQUEST_ACCEPTED,
	REQUEST_REFUSED,
	REQUEST_CLOSED,
	REQUEST_CANCELLED
};


typedef void(*requestFunction)(gint result, gpointer info, gpointer data);


class requestDialog: public basicWindow
{
	public:
		gboolean isServer,
				 isInfoWindowOnly;
	
		requestDialog(gboolean			_isServer, 
					  GtkWidget*		_specialWidget, 
					  gchar*			_topicText,
					  gchar* 			_infoText, 
					  gchar* 			_commentText, 
					  requestFunction 	_clickNotify, 
					  gpointer 			_data);
		~requestDialog();
	
		void setInfoWindowOnly(gboolean setting);
		void waitForRequestAnswer();
		void stopWaitForRequestAnswer();
		void setTopicInformation(gchar *_topicText, gchar* _infoText);
		void setComment(gchar* _commentText);
		void setRequestName(gchar* _requestName);
		gchar* askForReason(gchar* headline, gchar* hltext);

		virtual gboolean eventCallback(gint command, gint lastResult, gpointer info);
	
	
	protected:
		GtkWidget		*specialWidget,
						*sendButton,
						*closeButton,
						*serverCheckbox,
						*comment;
		gchar			*topicText,
						*infoText,
						*commentText,
						*requestName;
		requestFunction	clickNotify;
		gpointer		data;
	
		processingAni	*sendAni;
		
		virtual GtkWidget* createWindowContent();
		virtual void	   destroyWindowContent();
		virtual void	   closeWindow();
	

		GtkWidget*	createButtonbar();
	
		// callbacks
		static void cb_sendButtonClicked(requestDialog* rd);
		static void cb_refuseButtonClicked(requestDialog* rd);
		static void cb_closeButtonClicked(requestDialog* rd);
		static void cb_refuseWithReasonButtonClicked(requestDialog* rd);
		static void cb_sendServerButtonClicked(requestDialog* rd);
		static void cb_infoButtonClicked(requestDialog* rd);
		static void cb_historyButtonClicked(requestDialog* rd);
};


#endif /* _REQUESTDIALOG_H */
