/***************************************************************************
 *            settings.h
 *
 *  Mon Jul  5 23:37:40 2004
 *  Copyright  2004  User
 *  Email
 ****************************************************************************/

#ifndef _SETTINGS_H
#define _SETTINGS_H

#include "licq_icqd.h"

// #include "licq_plugin.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>

	
#define ICON_AWAY "icqnd-away"
#define ICON_BIRTHDAY "icqnd-birthday"
#define ICON_BLANK "icqnd-blank"
#define ICON_CHARSET "icqnd-charset"
#define ICON_CHAT "icqnd-chat"
#define ICON_CONNECT "icqnd-connect"
#define ICON_DND "icqnd-dnd"
#define ICON_FFC "icqnd-ffc"
#define ICON_FILE "icqnd-file"
#define ICON_HISTORY "icqnd-history"
#define ICON_INFO "icqnd-info"
#define ICON_INVISIBLE "icqnd-invisible"
#define ICON_INVISIBLE_ON "icqnd-invisible-on"
#define ICON_MESSAGE "icqnd-message"
#define ICON_NA "icqnd-na"
#define ICON_OCCUPIED "icqnd-occupied"
#define ICON_OFFLINE "icqnd-offline"
#define ICON_ONLINE "icqnd-online"
#define ICON_SECURE_ON "icqnd-secure-on"
#define ICON_SECUREBDAY "icqnd-securebday"
#define ICON_SMILEYS "icqnd-smileys"
#define ICON_URL "icqnd-url"
#define ICON_SHOWOFFLINE ICON_OFFLINE
#define ICON_DONTSHOWOFFLINE "icqnd-nooffline"
#define ICON_GROUPS "icqnd-groups"
#define ICON_SYSMSG "icqnd-sysmsg"

#define ICON_CONNECT0 "icqnd-connect0"
#define ICON_CONNECT1 "icqnd-connect1"
#define ICON_CONNECT2 "icqnd-connect2"
#define ICON_CONNECT3 "icqnd-connect3"
#define ICON_CONNECT4 "icqnd-connect4"
#define ICON_CONNECT5 "icqnd-connect5"
#define ICON_CONNECT6 "icqnd-connect6"
#define ICON_CONNECT7 "icqnd-connect7"
#define ICON_CONNECT8 "icqnd-connect8"

#define ICON_TYPING1  "icqnd-typing1"
#define ICON_TYPING2  "icqnd-typing2"
#define ICON_TYPING3  "icqnd-typing3"

#define STATE_CHAT "Frei für Chat"
#define STATE_ONLINE "Online"
#define STATE_AWAY "Weg"
#define STATE_NA "Nicht verfügbar"
#define STATE_OCCUPIED "Beschäftigt"
#define STATE_DND "Nicht stören"
#define STATE_OFFLINE "Offline"
#define STATE_INVISIBLE "Unsichtbar"
#define STATE_CONNECTING "Verbinde ..."

#define ICQND_ICON_SIZE_STD_STR "icqnd-icon-std"
#define ICQND_ICON_SIZE_LARGE_STR "icqnd-icon-large"
	
	
// #define NUM_LANGUAGES 62
// #define gLanguages ...

// #define NUM_COUNTRIES 242
// #define gCountries ...


/*
enum
{
	ICON_MESSAGE,
	ICON_URL,
	ICON_WANTCHAT,
	ICON_FILE,
	ICON_INFO,
	ICON_HISTORY,
	ICON_BLANK,
	ICON_CHAT,
	ICON_ONLINE,
	ICON_AWAY,
	ICON_NA,
	ICON_OCCUPIED,
	ICON_DND,
	ICON_OFFLINE,
	ICON_INVISIBLE,
	ICON_CONNECTING,
	ICON_SMILEYS
}; */
	
	
	
// Default window position and size	
typedef struct windowDefaults
{
	short int x,
			  y,
			  width,
			  height;
	
};


typedef struct awayMessages
{
	// FIXME: add other messages here
	gchar* last;
};


typedef struct defaultIconSizes
{
	gint normal,
		 large;
};


#define ICQND_TYPE_COLOR G_TYPE_POINTER

#define GDK_COLOR_SET(col,r,g,b)\
	(col)->red = r;				\
	(col)->green = g;			\
	(col)->blue = b;

#define GDK_COLOR_SET_AV(rescol, col1, col2)			\
	(rescol)->red = ((col1)->red + (col2)->red)/2;		\
	(rescol)->green = ((col1)->green + (col2)->green)/2;\
	(rescol)->blue = ((col1)->blue + (col2)->blue)/2;

typedef void (*settingChangedFunc)(gchar* sname, GList *values, gpointer data);


struct settingsFunc
{
	settingChangedFunc func;
	gpointer data;
};


struct settingsProperty
{
	gchar  *name;
	GValue *val;
};


struct settingsSection
{
	gchar *name;
	GList *properties;  // a list of settingsProperty
	GList *funcs;		// a list of settingsFunc
};



struct smileysNode
{
	gchar		character;
	GString		*summary;
	guchar		smileysIndex;
	GList		*children,
				*similies;
};


struct settingsSmiley
{
	GdkPixbuf 	*icon;
	gchar		*token;
};


class settings
{
	public:
		settings(gchar* filename);
		~settings();	
	
		// installs new properties in [section]
		// parameterorder: gchar* name, GType, default value if there is no entry in the config
		void installProperties(gchar* sname, ...); 
	
		// changes a property for a specific section
		void setProperties(gboolean inform, gchar* sname, ...);
	
		// gets properties
		void getProperties(gchar* sname, ...);
		
		// installs a listener for changes of a specific section
		void installListener(gchar* sname, settingChangedFunc func, gpointer data);
	
		// removes a listener for a section
		void removeListenerByData(gpointer data);
	
		// saves the settings
		gboolean writeSettings();
	
	
		GtkTextTagTable	*textTags;

		// things that are not saved in the config
		struct _images
		{
			settingsSmiley		smileys[28];
			GdkPixbufAnimation	*searchingAni;
		} images;
		
		smileysNode	*smileyTree;
	
	private:
	
		void	loadSmileys();
		void	loadIcons();
		void	loadTextTags();	
	
		void	createSmileyTree(smileysNode *node, guchar pos);
	
		CIniFile *licqFile;	
		GList	*sections;	// a list of settingSection
};


settings* settings_getSettings();
void	  settings_setSettings(settings *s);	




/*
// everything put together
class defaultSettings
{
	public:
		windowDefaults	 	*window;
		awayMessages		*awayMsgs;
		defaultIconSizes	iconSizes;
		gboolean			popupOnEvent;
		GdkPixbufAnimation	*searchingAni;
		GdkPixbuf			*smileys[28];
		GdkColor			colRed,
							colBlue,
							colTyping,
							colTypingStop,
							colConvFont,
							colConvBg;
		GtkTextTagTable		*textTags;
		bool				reverseHistory;
		gchar				*currentOwnerAlias;
		gchar				*fileDirectory;
		bool				colConvSetFont;
		bool				colConvSetBg;
	
		guchar				containerMode;
		
	
		defaultSettings();
		~defaultSettings();
		void 	 loadSettings(char* fileName);
		gboolean writeSettings(char* fileName);
		void	 loadIcons();
		void	 loadSmileys();

		void 	 createTextTags();
};


void setDefaultSettings(defaultSettings* settings);

defaultSettings* getDefaultSettings();

*/
#endif /* _SETTINGS_H */
