/***************************************************************************
 *            infowindow.cpp
 *
 *  Thu Feb 17 03:08:24 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "infowindow.h"



userInfoWindow::userInfoWindow()
{
	wType = UE_USERINFO;
}


userInfoWindow::~userInfoWindow()
{
	delete manager;
}


		
GtkWidget* userInfoWindow::createWindowContent()
{	
	GtkWidget	*pagetitle,
				*mainbox,
				*evbox;
	
	gint		i;
	
	gchar		*headlines[] =
	{tr_NOOP("Genera_l"), tr_NOOP("M_ore"), tr_NOOP("_Interests"), tr_NOOP("Wo_rk"), tr_NOOP("A_bout")};
	
	// create the notebook
	notebook = gtk_notebook_new();
	g_signal_connect(notebook, "switch-page", G_CALLBACK(this->cb_switchTab), this);
	gtk_container_set_border_width(GTK_CONTAINER(notebook), 6);
	
	tabs = NULL;
	
	for (i=0; i<5; i++)
	{
		pagetitle = gtk_label_new_with_mnemonic(tr(headlines[i]));
		evbox = gtk_event_box_new();
		tabs = g_list_append(tabs, evbox);
		gtk_notebook_append_page(GTK_NOTEBOOK(notebook), evbox , pagetitle);
		
	}
			
	
	// create main vbox	
	mainbox = gtk_vbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(mainbox), notebook, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(mainbox), createButtonbar(), FALSE, TRUE, 0);
	
	printf("Owner: %d\n", manager->parentUser);

	return mainbox;
}


GtkWidget* userInfoWindow::createButtonbar()
{
	GtkWidget	*btnbox;
	
	// set up animation
	sendAni = new processingAni();
	sendAni->setupAnimation(settings_getSettings()->images.searchingAni, 22, 22);
	
	// create buttons
	updateBtn 	= gtk_button_new_from_stock(GTK_STOCK_REFRESH);
	g_signal_connect_swapped(updateBtn, "clicked", G_CALLBACK(this->cb_updateButtonClicked), this);
	saveBtn		= gtk_button_new_from_stock(GTK_STOCK_SAVE);
	g_signal_connect_swapped(G_OBJECT(saveBtn), "clicked", G_CALLBACK(this->cb_saveButtonClicked), this);
	closeBtn	= gtk_button_new_from_stock(GTK_STOCK_CLOSE);
	g_signal_connect_swapped(closeBtn, "clicked", G_CALLBACK(this->cb_closeButtonClicked), this);
	
	if (!manager->parentUser->owner)
	{
		sendBtn = u_createTextStockImageButton("S_enden", GTK_STOCK_OK);
		g_signal_connect_swapped(sendBtn, "clicked", G_CALLBACK(this->cb_sendButtonClicked), this);
	}
		
	btnbox = gtk_hbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(btnbox), 6);
	
	gtk_box_pack_start(GTK_BOX(btnbox), sendAni->widget, FALSE, FALSE, 2);
	gtk_box_pack_start(GTK_BOX(btnbox), updateBtn, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(btnbox), saveBtn, FALSE, FALSE, 0);
	if (!manager->parentUser->owner)
		gtk_box_pack_start(GTK_BOX(btnbox), sendBtn, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(btnbox), closeBtn, FALSE, FALSE, 0);
	
	
	return btnbox;
}




GtkWidget* userInfoWindow::createGeneralTab()
{
	GtkWidget	*table,
				*label,
				*alignment;
	gchar		*tmp;
		
	table = gtk_table_new(11, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Alias:"), info_alias, manager->info->alias, 0, 2, 0);
	info_keepalias = gtk_check_button_new_with_label(tr("Keep alias on update"));
	if (!manager->parentUser->owner)
		gtk_widget_set_no_show_all(info_keepalias, TRUE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
	gtk_table_attach_defaults(GTK_TABLE(table), info_keepalias, 2, 4, 0, 1);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ID:"), info_uin, manager->info->formattedID, 0, 2, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_uin), FALSE);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("IP:"), info_ip, manager->info->formattedIP, 2, 4, 1);
	gtk_editable_set_editable(GTK_EDITABLE(info_ip), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Status:"), info_constate, uu_getStatusDescription(manager->info->status), 0, 2, 2);
	tmp = g_strdup_printf("GMT%+d00", -manager->info->gmtoffset/3600);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Time zone:"), info_timezone, tmp, 2, 4, 2);
	g_free(tmp);
	gtk_editable_set_editable(GTK_EDITABLE(info_timezone), FALSE);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Name:"), info_name1, manager->info->firstname, 0, 2, 3);
	info_name2 = gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(info_name2), manager->info->lastname);
	gtk_table_attach_defaults(GTK_TABLE(table), info_name2, 2, 4, 3, 4);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email 1:"), info_email1, manager->info->email1, 0, 4, 4);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email 2:"), info_email2, manager->info->email2, 0, 4, 5);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Email old:"), info_emailold, manager->info->email3, 0, 4, 6);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Address:"), info_address, manager->info->home.address, 0, 2, 7);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Phone:"), info_tel, manager->info->home.phone, 2, 4, 7);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("State:"), info_state, manager->info->home.state, 0, 2, 8);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Fax:"), info_fax, manager->info->home.fax, 2, 4, 8);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("City:"), info_city, manager->info->home.city, 0, 2, 9);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Mobile:"), info_mobile, manager->info->home.mobile, 2, 4, 9);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ZIP:"), info_zip, manager->info->home.zip, 0, 2, 10);
	UIT_MAKE_LIST_BOX(info_country, manager->info->home.country, NUM_COUNTRIES, gCountries);
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Country:"), info_country, 2, 4, 10);
	
	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	
	return alignment;	
}


GtkWidget* userInfoWindow::createMoreTab()
{
	GtkWidget	*table,
				*label,
				*alignment,
				*bdlabel,
				*bmlabel,
				*bylabel,
				*hbox;
	
	table = gtk_table_new(4, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 5);
	
	
	info_age = gtk_spin_button_new_with_range(0, 999, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_age), manager->info->age);

	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Age:"), info_age, 0, 2, 0);
		
	info_gender = gtk_combo_box_new_text();
	gtk_widget_set_size_request(info_gender, 100, -1);
	
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Not specified"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Female"));
	gtk_combo_box_append_text(GTK_COMBO_BOX(info_gender), tr("Male"));
	gtk_combo_box_set_active(GTK_COMBO_BOX(info_gender), manager->info->gender);
	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Gender:"), info_gender, 2, 4, 0);
	
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Web page:"), info_isite, manager->info->website, 0, 4, 1);
	
	
	bdlabel = gtk_label_new(tr("Day:"));
	bmlabel = gtk_label_new(tr("Month:"));
	bylabel = gtk_label_new(tr("Year:"));
	info_birthday = gtk_spin_button_new_with_range(1, 31, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthday), manager->info->birthday.day);
	info_birthmonth = gtk_spin_button_new_with_range(1, 12, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthmonth), manager->info->birthday.month);
	info_birthyear	= gtk_spin_button_new_with_range(1900, 1900+0xFF, 1);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info_birthyear), manager->info->birthday.year);
	hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox), bdlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthday, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bmlabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthmonth, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), bylabel, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_birthyear, FALSE, FALSE, 0);

	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Birthday:"), hbox, 0, 4, 2);


	
	hbox = gtk_hbox_new(FALSE, 2);
	
	
	UIT_MAKE_LIST_BOX(info_language1, manager->info->language1, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language2, manager->info->language2, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_LIST_BOX(info_language3, manager->info->language3, NUM_LANGUAGES, gLanguages);
	
	gtk_box_pack_start(GTK_BOX(hbox), info_language1, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), info_language3, TRUE, TRUE, 0);

	
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Languages:"), hbox, 0, 4, 3);
	
	
	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	
	return alignment;
}




GtkWidget* userInfoWindow::createWorkTab()
{
	GtkWidget	*table,
				*label,
				*alignment;
	
	table = gtk_table_new(11, 7, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table), 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Name:"), info_companyName, manager->info->company.name, 0, 4, 0);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Department:"), info_companyDep, manager->info->company.department, 0, 2, 1);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Position:"), info_companyPos, manager->info->company.position, 2, 4, 1);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("City:"), info_companyCity, manager->info->company.city, 0, 2, 2);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("State:"), info_companyState, manager->info->company.state, 2, 4, 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Address:"), info_companyAddress, manager->info->company.address, 0, 4, 3);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("ZIP:"), info_companyZip, manager->info->company.zip, 0, 2, 4);
	UIT_MAKE_LIST_BOX(info_companyCountry, manager->info->company.country, NUM_COUNTRIES, gCountries);
	UIT_MAKE_TABLE_ROW_CUSTOM(table, label, tr("Country:"), info_companyCountry, 2, 4, 4);

	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Phone:"), info_companyTel, manager->info->company.phone, 0, 2, 5);
	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Fax:"), info_companyFax, manager->info->company.fax, 2, 4, 5);

	UIT_MAKE_TABLE_ROW_ENTRY(table, label, tr("Web page:"), info_companyISite, manager->info->company.website, 0, 4, 6);


	alignment = gtk_alignment_new(0.0f, 0.0f, 1.0f, 0.0f);
	gtk_container_add(GTK_CONTAINER(alignment), table);
	
	return alignment;
}


GtkWidget* userInfoWindow::createAboutTab()
{
	GtkWidget		*aboutframe;
	GtkTextIter 	start;
	GtkTextBuffer	*buf;
	
	aboutframe = u_createTextView(&info_about);
	
	buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(info_about));
	
	gtk_text_buffer_get_start_iter(buf, &start);
	
	gtk_text_buffer_insert(buf, &start, manager->info->about, strlen(manager->info->about));
	
	return aboutframe;
}


GtkWidget* userInfoWindow::createLastTab()
{
	return NULL;
}


GtkWidget* userInfoWindow::createInterestsTab()
{
	return gtk_label_new("Work is in progress ...");
}






void userInfoWindow::destroyWindowContent()
{
	stopUpdate();
}


		
gboolean userInfoWindow::eventCallback(gint comment, gint lastResult, gpointer info)
{
	switch(comment)
	{
		case UC_EVENT_FINISHED:

			stopUpdate();
		
			if (lastResult != EVENT_RESULT_ACKED && lastResult != EVENT_RESULT_SUCCESS)
				uu_showSendErrorMessage(tr("Could not update"), tr("Updating of the user failed"), lastResult, manager->parentUser->info->status);
			else
			if (((IMUserUpdateManager*)manager)->sendUpdateStep == 0)
				shiftInformation(TRUE);
			break; 
	}
	
	return TRUE;
}




void userInfoWindow::startUpdate()
{
	gtk_widget_set_sensitive(notebook, FALSE);
	gtk_widget_set_sensitive(saveBtn, FALSE);
	gtk_widget_set_sensitive(updateBtn, FALSE);
	if (!manager->parentUser->owner)
		gtk_widget_set_sensitive(sendBtn, FALSE);
	
	gtk_button_set_label(GTK_BUTTON(closeBtn), GTK_STOCK_CANCEL);
	gtk_button_set_use_stock(GTK_BUTTON(closeBtn), TRUE);
	
	sendAni->play();
}



void userInfoWindow::stopUpdate()
{	
	gtk_widget_set_sensitive(notebook, TRUE);
	gtk_widget_set_sensitive(saveBtn, TRUE);
	gtk_widget_set_sensitive(updateBtn, TRUE);
	if (!manager->parentUser->owner)
		gtk_widget_set_sensitive(sendBtn, TRUE);
	
	gtk_button_set_label(GTK_BUTTON(closeBtn), GTK_STOCK_CLOSE);
	gtk_button_set_use_stock(GTK_BUTTON(closeBtn), TRUE);	
	sendAni->stop();
	
	manager->cancelInitatedEvent();
}






#define UIWT_SHIFTINFO_ENTRY(uinf, entry)										\
	if (!update && gtk_editable_get_editable(GTK_EDITABLE(entry)))				\
	{																			\
		g_free(manager->info->uinf);											\
		manager->info->uinf = g_strdup(gtk_entry_get_text(GTK_ENTRY(entry)));	\
	} else																		\
		gtk_entry_set_text(GTK_ENTRY(entry), manager->info->uinf);

	
#define UIWT_SHIFTINFO_SPIN(uinf, spin)											\
	if (update)																	\
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(spin), manager->info->uinf);	\
	else																		\
		manager->info->uinf = gtk_spin_button_get_value(GTK_SPIN_BUTTON(spin));
	

#define UIWT_SHIFTINFO_COMBO(uinf, combo)										\
	if (update)																	\
		gtk_combo_box_set_active(GTK_COMBO_BOX(combo), manager->info->uinf);	\
	else																		\
		manager->info->uinf = gtk_combo_box_get_active(GTK_COMBO_BOX(combo));


void userInfoWindow::shiftInformation(gboolean update)
{
	GtkTextBuffer*	buf;
	GtkTextIter		start, end;
	
	// general
	if (!g_list_nth_data(tabs, 0))
	{
		UIWT_SHIFTINFO_ENTRY(alias, info_alias);
		if (update)
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info_keepalias), manager->info->keepAlias);
		else
			manager->info->keepAlias = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(info_keepalias));
		UIWT_SHIFTINFO_ENTRY(firstname, info_name1);
		UIWT_SHIFTINFO_ENTRY(lastname, info_name2);
		UIWT_SHIFTINFO_ENTRY(formattedID, info_uin);
		UIWT_SHIFTINFO_ENTRY(formattedIP, info_ip);
		UIWT_SHIFTINFO_ENTRY(email1, info_email1);
		UIWT_SHIFTINFO_ENTRY(email2, info_email2);
		UIWT_SHIFTINFO_ENTRY(email3, info_emailold);
		UIWT_SHIFTINFO_ENTRY(home.address, info_address);
		UIWT_SHIFTINFO_ENTRY(home.phone, info_tel);
		UIWT_SHIFTINFO_ENTRY(home.state, info_state);
		UIWT_SHIFTINFO_ENTRY(home.fax, info_fax);
		UIWT_SHIFTINFO_ENTRY(home.city, info_city);
		UIWT_SHIFTINFO_ENTRY(home.mobile, info_mobile);
	}


	if (!g_list_nth_data(tabs, 1))
	{
		// more	
		UIWT_SHIFTINFO_SPIN(age, info_age);
		UIWT_SHIFTINFO_COMBO(gender, info_gender);
		UIWT_SHIFTINFO_SPIN(birthday.day, info_birthday);
		UIWT_SHIFTINFO_SPIN(birthday.month, info_birthmonth);
		UIWT_SHIFTINFO_SPIN(birthday.year, info_birthyear);
		// languages
	}
	
	
	if (!g_list_nth_data(tabs, 3))
	{
		// work
		UIWT_SHIFTINFO_ENTRY(company.name, info_companyName);
		UIWT_SHIFTINFO_ENTRY(company.department, info_companyDep);
		UIWT_SHIFTINFO_ENTRY(company.position, info_companyPos);
		UIWT_SHIFTINFO_ENTRY(company.city, info_companyCity);
		UIWT_SHIFTINFO_ENTRY(company.state, info_companyState);
		UIWT_SHIFTINFO_ENTRY(company.address, info_companyAddress);
		UIWT_SHIFTINFO_ENTRY(company.zip, info_companyZip);
		// country
		UIWT_SHIFTINFO_ENTRY(company.phone, info_companyTel);
		UIWT_SHIFTINFO_ENTRY(company.fax, info_companyFax);
		UIWT_SHIFTINFO_ENTRY(company.website, info_companyISite);
	}


	if (!g_list_nth_data(tabs, 4))
	{
		// about	
		buf = gtk_text_view_get_buffer(GTK_TEXT_VIEW(info_about));

		if (update)
		{
			gtk_text_buffer_set_text(buf, manager->info->about, strlen(manager->info->about));
		} else
		{
			gtk_text_buffer_get_bounds(buf, &start, &end);		
			g_free(manager->info->about);
			manager->info->about = gtk_text_buffer_get_text(buf, &start, &end, FALSE);
		}
	}
}



void userInfoWindow::cb_updateButtonClicked(userInfoWindow* uiw)
{
	uiw->startUpdate();
		
	if (!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(uiw->info_keepalias)))
		((IMUserUpdateManager*)uiw->manager)->updateUserInfo(NULL);
	else
		((IMUserUpdateManager*)uiw->manager)->updateUserInfo((gchar*)gtk_entry_get_text(GTK_ENTRY(uiw->info_alias)));		
}


void userInfoWindow::cb_sendButtonClicked(userInfoWindow* uiw)
{
	uiw->shiftInformation(FALSE);
	uiw->startUpdate();
		
	((IMUserUpdateManager*)uiw->manager)->sendUserInfo();
}



void userInfoWindow::cb_closeButtonClicked(userInfoWindow* uiw)
{
	if (uiw->manager->initatedEventID != 0)
		uiw->stopUpdate();
	else
	{
		uiw->destroyWindow();
		delete uiw;
	}
}


void userInfoWindow::cb_saveButtonClicked(userInfoWindow* uiw)
{
	uiw->shiftInformation(FALSE);
	((IMUserUpdateManager*)uiw->manager)->saveUserInfo();
}




void userInfoWindow::cb_switchTab(GtkWidget *w, GtkNotebookPage *page, guint newTab, userInfoWindow* uiw)
{
	GtkWidget	*box,
				*toadd;
	GList		*tmp;
	
	box = (GtkWidget*)g_list_nth_data(uiw->tabs, newTab);
	
	if (!box)
		return;
	
	if (! (tmp = gtk_container_get_children(GTK_CONTAINER(box))) )
	{
		toadd = NULL;
		
		switch(newTab)
		{
			case 0: toadd = uiw->createGeneralTab(); break;
			case 1: toadd = uiw->createMoreTab(); break;
			case 3: toadd = uiw->createWorkTab(); break;
			case 4: toadd = uiw->createAboutTab(); break;				
			default: toadd = gtk_label_new("Work is in progress...!\n"); break;				
		}
		
		gtk_container_add(GTK_CONTAINER(box), toadd);
		gtk_widget_show_all(box);
		
		g_list_nth(uiw->tabs, newTab)->data = NULL;
		
	} else
		g_list_free(tmp);
}
