/***************************************************************************
 *            searchdialog.cpp
 *
 *  Mon Jun  6 00:31:20 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#include "searchdialog.h"

struct _customListEntries
{
	gchar	*szName;
} ageRanges[7] =
{{tr_NOOP("Not specified")},
 {"18 - 22"},
 {"23 - 29"},
 {"30 - 39"},
 {"40 - 49"},
 {"50 - 59"},
 {"60+"}};
 
 _customListEntries gender[3] =
{{tr_NOOP("Not specified")},
 {"weiblich"},
 {"männlich"}
 };

searchForUserDialog::searchForUserDialog()
{
	wType = UE_WHITEPAGES;
}



searchForUserDialog::~searchForUserDialog()
{
	
}



GtkWidget* searchForUserDialog::createWindowContent()
{
	GtkWidget	*table1,
				*label,
				*hbox1,
				*vbox1;
	
	
	// *** create the white pages entry	***
	table1 = gtk_table_new(9, 4, FALSE);
	gtk_table_set_row_spacings(GTK_TABLE(table1), 2);
	
	// left column
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Alias:"), aliasEntry, "", 0, 2, 0);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("First name:"), fNameEntry, "", 0, 2, 1);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Last name:"), lNameEntry, "", 0, 2, 2);

	UIT_MAKE_LIST_BOX(ageList, 0, 7, ageRanges);
	UIT_MAKE_TABLE_ROW_CUSTOM(table1, label, tr("Age range:"), ageList, 0, 2, 3);

	UIT_MAKE_LIST_BOX(genderList, 0, 3, gender);
	UIT_MAKE_TABLE_ROW_CUSTOM(table1, label, tr("Gender:"), genderList, 0, 2, 4);
	
	UIT_MAKE_LIST_BOX(langList, 0, NUM_LANGUAGES, gLanguages);
	UIT_MAKE_TABLE_ROW_CUSTOM(table1, label, tr("Language:"), langList, 0, 2, 5);

	// right column
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("City:"), cityEntry, "", 2, 4, 0);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("State:"), stateEntry, "", 2, 4, 1);
	
	UIT_MAKE_LIST_BOX(countryList, 0, NUM_COUNTRIES, gCountries);
	UIT_MAKE_TABLE_ROW_CUSTOM(table1, label, tr("Country:"), countryList, 2, 4, 2);
	
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Comp. name:"), companyNameEntry, "",2, 4, 3);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Comp. dep:"), companyDepEntry, "",2, 4, 4);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Comp. pos:"), companyPosEntry, "",2, 4, 5);
	
	
	// bottom column
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Email:"), emailEntry, "", 0, 4, 6);
	UIT_MAKE_TABLE_ROW_ENTRY(table1, label, tr("Key word"), keywordEntry, "", 0, 4, 7);
	
	// online checkbox
	onlineCheckbox = gtk_check_button_new_with_mnemonic(tr("Return _online users only"));
	gtk_table_attach_defaults(GTK_TABLE(table1), onlineCheckbox, 0, 4, 8, 9);
	
	
	// *** create the uin search tab ***
	hbox1 = gtk_hbox_new(FALSE, 2);
	uinEntry = gtk_entry_new();
	label = gtk_label_new(tr("ICQ Number:"));
	gtk_box_pack_start(GTK_BOX(hbox1), label, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox1), uinEntry, TRUE, TRUE, 0);
	
	
	// *** create the notebook ***
	notebook = gtk_notebook_new();
	
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), table1, gtk_label_new_with_mnemonic("_Whitepages"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), hbox1, gtk_label_new_with_mnemonic("_Icq-Nummer"));
	
		
	// *** add everything into a vbox
	vbox1 = gtk_vbox_new(FALSE, 7);
	gtk_container_set_border_width(GTK_CONTAINER(vbox1), 4);
	gtk_box_pack_start(GTK_BOX(vbox1), notebook, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox1), createResultsList(), TRUE, TRUE, 0);
//	gtk_box_pack_start(GTK_BOX(vbox1), hbox2, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox1), gtk_hseparator_new(), FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox1), createButtonbar(), FALSE, TRUE, 0);
	
	
	updateUserButtons();
	
	
	return vbox1;
}



GtkWidget* searchForUserDialog::createResultsList()
{
	GtkCellRenderer		*renderer;
	GtkTreeViewColumn	*column;
	GtkWidget			*scrolled,
						*hbox2,
						*vbox,
						*frame1;
	
	
	resultsStore = gtk_list_store_new(7, G_TYPE_STRING,		// alias 
										 G_TYPE_STRING, 	// uin
										 G_TYPE_STRING, 	// name
										 G_TYPE_STRING, 	// email
										 G_TYPE_STRING,		// status
										 G_TYPE_STRING,		// sex & age
										 G_TYPE_BOOLEAN);	// authorize
	
	resultsView = gtk_tree_view_new_with_model(GTK_TREE_MODEL(resultsStore));
	gtk_tree_selection_set_mode(gtk_tree_view_get_selection(GTK_TREE_VIEW(resultsView)), GTK_SELECTION_MULTIPLE);
	g_signal_connect_swapped(gtk_tree_view_get_selection(GTK_TREE_VIEW(resultsView)), "changed", G_CALLBACK(this->cb_moveResultsFocus), this);

	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(resultsView), TRUE);
	
	// make the alias column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Alias"), 
													  renderer, 
													  "text", SFU_ALIAS, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_ALIAS);


	// make the uin column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Id"), 
													  renderer, 
													  "text", SFU_UIN, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_UIN);	
	
	// make the name column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Name"), 
													  renderer, 
													  "text", SFU_NAME, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);	
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_NAME);
	
	// make the email column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Email"), 
													  renderer, 
													  "text", SFU_EMAIL, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);	
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_EMAIL);

	// make the status column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Status"), 
													  renderer, 
													  "text", SFU_STATUS, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);	
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_STATUS);
	
	// make the sex and age column
	renderer = gtk_cell_renderer_text_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Gender / Age"), 
													  renderer, 
													  "text", SFU_SEXAGE, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);	
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_SEXAGE);

	// make the sex and age column
	renderer = gtk_cell_renderer_toggle_new();
	column = gtk_tree_view_column_new_with_attributes(tr("Need authorization"), 
													  renderer, 
													  "active", SFU_AUTHORIZE, 
													  NULL);
	gtk_tree_view_column_set_expand(column, TRUE);
	gtk_tree_view_append_column(GTK_TREE_VIEW(resultsView), column);
	gtk_tree_view_column_set_clickable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_resizable(GTK_TREE_VIEW_COLUMN(column), TRUE);
	gtk_tree_view_column_set_sort_column_id(GTK_TREE_VIEW_COLUMN(column), SFU_AUTHORIZE);

	scrolled = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled),
								   GTK_POLICY_AUTOMATIC,
								   GTK_POLICY_AUTOMATIC );
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolled),
										GTK_SHADOW_IN);
	gtk_container_add(GTK_CONTAINER(scrolled), resultsView);


	// create the tool buttons
	
	infoButton = u_createStockImageButton(ICON_INFO);
	g_object_set_data(G_OBJECT(infoButton), "icqnd-searchev", GUINT_TO_POINTER(UE_USERINFO));
	g_signal_connect(infoButton, "clicked", G_CALLBACK(this->cb_userButtonClicked), this);

	messageButton = u_createStockImageButton(ICON_MESSAGE);
	g_object_set_data(G_OBJECT(messageButton), "icqnd-searchev", GUINT_TO_POINTER(UE_MESSAGE));
	g_signal_connect(messageButton, "clicked", G_CALLBACK(this->cb_userButtonClicked), this);

	chatButton = u_createStockImageButton(ICON_CHAT);
	g_object_set_data(G_OBJECT(chatButton), "icqnd-searchev", GUINT_TO_POINTER(UE_CHATREQUEST));
	g_signal_connect(chatButton, "clicked", G_CALLBACK(this->cb_userButtonClicked), this);

	filetransferButton = u_createStockImageButton(ICON_FILE);
	g_object_set_data(G_OBJECT(filetransferButton), "icqnd-searchev", GUINT_TO_POINTER(UE_FILETRANSFERREQUEST));
	g_signal_connect(filetransferButton, "clicked", G_CALLBACK(this->cb_userButtonClicked), this);

	// create the add user buttons 
	addUserButton = gtk_button_new_with_mnemonic("");
	gtk_button_set_relief(GTK_BUTTON(addUserButton), GTK_RELIEF_HALF);
	g_signal_connect_swapped(addUserButton, "clicked", G_CALLBACK(this->cb_addUsersButtonClicked), this);
	
	alertUserCheckbox = gtk_check_button_new_with_mnemonic(tr("_Alert user"));
	
	hbox2 = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox2), infoButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), messageButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), chatButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox2), filetransferButton, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(hbox2), addUserButton, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(hbox2), alertUserCheckbox, FALSE, FALSE, 5);


	// create the status label
	statusLabel = gtk_label_new(tr("<small>Ready ...</small>"));
	gtk_label_set_use_markup(GTK_LABEL(statusLabel), TRUE);
	gtk_misc_set_alignment(GTK_MISC(statusLabel), 0.0f, 0.5f);


	// add everything into a vbox
	vbox = gtk_vbox_new(FALSE, 2);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 2);
	gtk_box_pack_start(GTK_BOX(vbox), scrolled, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), statusLabel, FALSE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, TRUE, 0);


	// add a frame around it
	frame1 = gtk_frame_new(NULL);
	gtk_frame_set_shadow_type(GTK_FRAME(frame1), GTK_SHADOW_OUT);
	gtk_container_add(GTK_CONTAINER(frame1), vbox);

	
	return frame1;
}



GtkWidget* searchForUserDialog::createButtonbar()
{
	GtkWidget	*hbox;
	
	searchAni = new processingAni();
	searchAni->setupAnimation(settings_getSettings()->images.searchingAni, 22, 22);
	
	searchButton = gtk_button_new_from_stock(GTK_STOCK_FIND);
	g_signal_connect_swapped(searchButton, "clicked", G_CALLBACK(this->cb_searchButtonClicked), this);
	resetButton = gtk_button_new_from_stock(GTK_STOCK_CLEAR);
	g_signal_connect_swapped(resetButton, "clicked", G_CALLBACK(this->cb_resetButtonClicked), this);
	closeButton = gtk_button_new_from_stock(GTK_STOCK_CLOSE);
	g_signal_connect_swapped(closeButton, "clicked", G_CALLBACK(this->cb_closeButtonClicked), this);
	
	hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(hbox), searchAni->widget, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), resetButton, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), searchButton, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(hbox), closeButton, FALSE, FALSE, 0);
	
	return hbox;
}




void searchForUserDialog::destroyWindowContent()
{
	searchAni->stop();
	delete searchAni;
}


void searchForUserDialog::updateUserButtons()
{
	GtkTreePath* 		path;
	GtkTreeSelection	*sel;
	gint				rows;
	gchar				buf[1000];
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(resultsView), &path, NULL);

	if (!path) 
	{
		gtk_widget_set_sensitive(infoButton, FALSE);
		gtk_widget_set_sensitive(messageButton, FALSE);
		gtk_widget_set_sensitive(chatButton, FALSE);
		gtk_widget_set_sensitive(filetransferButton, FALSE);
	} else
	{
		gtk_widget_set_sensitive(infoButton, TRUE);
		gtk_widget_set_sensitive(messageButton, TRUE);
		gtk_widget_set_sensitive(chatButton, TRUE);
		gtk_widget_set_sensitive(filetransferButton, TRUE);		
		gtk_tree_path_free(path);
	}
	
	sel = gtk_tree_view_get_selection(GTK_TREE_VIEW(resultsView));
	rows = gtk_tree_selection_count_selected_rows(sel);
	
	sprintf(buf, tr("Add %d users"), rows);
	gtk_button_set_label(GTK_BUTTON(addUserButton), buf);
	gtk_button_set_use_underline(GTK_BUTTON(addUserButton), TRUE);
	
	if (!rows)
		gtk_widget_set_sensitive(addUserButton, FALSE);
	else
		gtk_widget_set_sensitive(addUserButton, TRUE);
}



void searchForUserDialog::addSearchResult(searchEventInfo *searchInfo)
{
	GtkTreeIter		iter;
	GString			*name,
					*sex;
	gchar			*status;
	gchar			buf[1000],
					buf2[1000];
	
	name = g_string_new(searchInfo->firstName);
	if (strlen(name->str)>0 && strlen(searchInfo->lastName)>0)
		name = g_string_append(name, " ");
	name = g_string_append(name, searchInfo->lastName);
			
	sex = g_string_new("");
	switch(searchInfo->gender)
	{
		case 1: sex = g_string_append(sex, tr("f ")); break;
		case 2: sex = g_string_append(sex, tr("m ")); break;
		default: sex = g_string_append(sex, "? "); break;
	}
			
	switch(searchInfo->status)
	{
		case 0: status = tr("Offline"); break;
		case 1: status = tr("Online"); break;
		default: status = tr("Unknown"); break;
	}
			
	g_string_append_printf(sex, " %d", searchInfo->age); 
	
	gtk_list_store_append(resultsStore, &iter);
	gtk_list_store_set(resultsStore, &iter,
					   SFU_ALIAS, searchInfo->alias,
					   SFU_UIN, searchInfo->id,
					   SFU_NAME, name->str,
					   SFU_EMAIL, searchInfo->email,
					   SFU_STATUS, status,
					   SFU_SEXAGE, sex->str,
					   SFU_AUTHORIZE, searchInfo->requireAuthorization,
					   -1);
	g_string_free(name, TRUE);
	g_string_free(sex, TRUE);
	
	if (searchInfo->lastEntry)
	{
		if (searchInfo->more == 0)
			buf2[0] = 0;
		else
		if (searchInfo->more < 0)
			sprintf(buf2, tr_NOOP(", many more results"));
		else
			sprintf(buf2, tr_NOOP(", %d more not displayed results"), searchInfo->more);
		
		sprintf(buf, tr("<small>Search finished (%d Results%s)</small>"), gtk_tree_model_iter_n_children(GTK_TREE_MODEL(resultsStore), NULL), buf2);		
	}
	else
		sprintf(buf, tr("<small>Searching (%d Hits) ...</small>"), gtk_tree_model_iter_n_children(GTK_TREE_MODEL(resultsStore), NULL));

	gtk_label_set_markup(GTK_LABEL(statusLabel), buf);
}



gboolean searchForUserDialog::eventCallback(gint command, gint lastResult, gpointer info)
{
	if (command != UC_EVENT_FINISHED)
		return TRUE;
	
	if (lastResult != EVENT_RESULT_ACKED && lastResult != EVENT_RESULT_SUCCESS)
	{
		uu_showSendErrorMessage(tr("Error while searching"), tr("Could not search for users"), lastResult, manager->parentUser->info->status);
		stopSearch();
		gtk_label_set_markup(GTK_LABEL(statusLabel), tr("<small>Error ...</small>"));
	} else
	{
		
		if (info)
		{
			addSearchResult((searchEventInfo*)info);
			if (((searchEventInfo*)info)->lastEntry)
				stopSearch();
		}
		else
		{
			if (!gtk_tree_model_iter_n_children(GTK_TREE_MODEL(resultsStore), NULL))
				gtk_label_set_markup(GTK_LABEL(statusLabel), tr("<small>Search finished (no results)</small>"));
			stopSearch();
			
		}
		
	}
	
	return TRUE;
}

	
	
	
void searchForUserDialog::startSearch()
{
	gushort ageMin[7] = {0, 18, 23, 30, 40, 50, 60};
	gushort ageMax[7] = {0, 22, 29, 39, 49, 59, 120};
	
	gtk_widget_set_sensitive(notebook, FALSE);
	gtk_widget_set_sensitive(searchButton, FALSE);
	gtk_button_set_label(GTK_BUTTON(closeButton), GTK_STOCK_CANCEL);
	gtk_button_set_use_stock(GTK_BUTTON(closeButton), TRUE);
	searchAni->play();
	
	if (gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook))==1)
		((IMUserSearchManager*)manager)->searchByID((gchar*)gtk_entry_get_text(GTK_ENTRY(uinEntry)));
	else
		((IMUserSearchManager*)manager)->searchWhitePages((gchar*)gtk_entry_get_text(GTK_ENTRY(fNameEntry)), 
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(lNameEntry)), 
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(aliasEntry)), 
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(emailEntry)), 
														  ageMin[gtk_combo_box_get_active(GTK_COMBO_BOX(ageList))], 
														  ageMax[gtk_combo_box_get_active(GTK_COMBO_BOX(ageList))], 
														  gtk_combo_box_get_active(GTK_COMBO_BOX(genderList)),
														  GetLanguageByIndex(gtk_combo_box_get_active(GTK_COMBO_BOX(langList)))->nCode,
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(cityEntry)),
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(stateEntry)),
														  GetCountryByIndex(gtk_combo_box_get_active(GTK_COMBO_BOX(countryList)))->nCode,
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(companyNameEntry)),
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(companyDepEntry)),
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(companyPosEntry)),
														  (gchar*)gtk_entry_get_text(GTK_ENTRY(keywordEntry)),
														  gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(onlineCheckbox)));
	
	gtk_list_store_clear(resultsStore);
	// updateUserButtons();
	
	gtk_label_set_markup(GTK_LABEL(statusLabel), tr("<small>Searching ...</small>"));
}



void searchForUserDialog::stopSearch()
{
	gtk_widget_set_sensitive(notebook, TRUE);
	gtk_widget_set_sensitive(searchButton, TRUE);
	gtk_button_set_label(GTK_BUTTON(closeButton), GTK_STOCK_CLOSE);
	gtk_button_set_use_stock(GTK_BUTTON(closeButton), TRUE);	
	searchAni->stop();
	
	if (manager->initatedEventID != 0)
	{
		gtk_label_set_markup(GTK_LABEL(statusLabel), tr("<small>Cancel!</small>"));
		manager->cancelInitatedEvent();
	}
}



void searchForUserDialog::resetSearch()
{
	gtk_list_store_clear(resultsStore);
	// updateUserButtons();
	gtk_entry_set_text(GTK_ENTRY(aliasEntry), "");
	gtk_entry_set_text(GTK_ENTRY(fNameEntry), "");
	gtk_entry_set_text(GTK_ENTRY(lNameEntry), "");
	gtk_entry_set_text(GTK_ENTRY(cityEntry), "");
	gtk_entry_set_text(GTK_ENTRY(stateEntry), "");
	gtk_entry_set_text(GTK_ENTRY(companyNameEntry), "");
	gtk_entry_set_text(GTK_ENTRY(companyDepEntry), "");
	gtk_entry_set_text(GTK_ENTRY(companyPosEntry), "");
	gtk_entry_set_text(GTK_ENTRY(emailEntry), "");
	gtk_entry_set_text(GTK_ENTRY(keywordEntry), "");
	gtk_entry_set_text(GTK_ENTRY(uinEntry), "");
	
	gtk_combo_box_set_active(GTK_COMBO_BOX(ageList), 0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(genderList), 0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(langList), 0);
	gtk_combo_box_set_active(GTK_COMBO_BOX(countryList), 0);
	
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(onlineCheckbox), FALSE);
	
	if (!manager->initatedEventID)
		gtk_label_set_markup(GTK_LABEL(statusLabel), tr("<small>Ready ...</small>"));
}




void searchForUserDialog::cb_searchButtonClicked(searchForUserDialog* self)
{
	self->startSearch();
}



void searchForUserDialog::cb_resetButtonClicked(searchForUserDialog* self)
{
	self->resetSearch();
}



void searchForUserDialog::cb_closeButtonClicked(searchForUserDialog* self)
{
	if (self->manager->initatedEventID != 0)
		self->stopSearch();
	else
	{
		self->destroyWindow();
		delete self;
	}
}


void searchForUserDialog::cb_moveResultsFocus(searchForUserDialog* self)
{
	self->updateUserButtons();
}



void searchForUserDialog::cb_userButtonClicked(GtkWidget* w, searchForUserDialog* self)
{
	IMUserDaemon	*user;
	IMBuddy			*buddy;
	guint toCall;
	GtkTreePath* path;
	GtkTreeIter iter;
	gchar	*id,
			*alias;
	
	gtk_tree_view_get_cursor(GTK_TREE_VIEW(self->resultsView), &path, NULL);
	
	if (path)
	{
		gtk_tree_model_get_iter(GTK_TREE_MODEL(self->resultsStore), &iter, path);
		gtk_tree_model_get(GTK_TREE_MODEL(self->resultsStore), &iter,
						   SFU_ALIAS, &alias,
						   SFU_UIN, &id,
						   -1);

		if (!(user = ((IMOwnerDaemon*)self->manager->parentUser)->findUserByID(id)))
		{
			user = ((IMOwnerDaemon*)self->manager->parentUser)->addUserTemporally(id);
			user->info->alias = g_strdup(alias);
		}			
		
		if (!user->dowry)
			buddy = new IMBuddy(user);
		else
			buddy = (IMBuddy*)user->dowry;
		
		
		toCall = GPOINTER_TO_UINT(g_object_get_data(G_OBJECT(w), "icqnd-searchev"));
		buddy->openEvent((userEventType)toCall, FALSE);

		gtk_tree_path_free(path);
	}
}



void searchForUserDialog::cb_addUsersButtonClicked(searchForUserDialog* self)
{
	GList	*sel,
			*search;
	gchar	*id;
	GtkTreeIter iter;
	gboolean doAlert;
	
	sel = gtk_tree_selection_get_selected_rows(gtk_tree_view_get_selection(GTK_TREE_VIEW(self->resultsView)), NULL);
	
	doAlert = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(self->alertUserCheckbox));
	
	if (sel)
	{
		search = sel;
		while(search)
		{
			gtk_tree_model_get_iter(GTK_TREE_MODEL(self->resultsStore), &iter, (GtkTreePath*)search->data);
			gtk_tree_model_get(GTK_TREE_MODEL(self->resultsStore), &iter,
							   SFU_UIN, &id,
							   -1);
			((IMOwnerDaemon*)self->manager->parentUser)->addUserToList(id, doAlert);
							   
			
			search = search->next;
		}
		
		g_list_foreach(sel, (GFunc)gtk_tree_path_free, NULL);
		g_list_free(sel);
	}
}
